Subject: bug#19012: 25.0.50; `help-window-select'

From: martin rudalics <[email-masked]>
Date: Mon, 17 Nov 2014 10:29:15 +0100

> How so?  Can you discuss those problems?  Is adding that sexp
 > to `help-window-setup' worse than if the equivalent behavior
 > were done in `with-output-to-temp-buffer'?  IOW, if a user
 > fiddles with the temp-buffer hooks, is that workaround any
 > less problematic?

Not for the user.  But users fiddling with these hooks affect their own
systems only.

 > If so, maybe you can fix the problem by doing the equivalent
 > of a user fiddling with hooks that way.  IOW, maybe put that
 > code in the code that runs the hooks, instead of telling
 > users put it in the hooks.

Again I would affect users who don't work with multiple frames.

 > I'm speculating, because you have said nothing about what
 > the problems are that make things "less simple than [you]
 > thought initially".

I initially thought (like you did too) that Emacs would not send a
request to focus a frame that already has focus.  After looking into
this I noticed that it does send a request unconditionally.

 >> It sends a request to the window manager because Emacs doesn't
 >> necessarily check whether the frame already has focus.  This
 >> might not harm on Windows but it might harm on other platforms.
 >
 > Then either (1) do it and wait to see if problems are reported
 > for other platforms or (2) do it just for Windows (that's simple
 > enough to do).

It's not nice to do that even for Windows only.

 > IOW why make the ideal into the enemy of the good?  And why
 > assume that there will be problems on other platforms?

Because I try to be as minimally invasive as possible.

 > I appreciate your efforts on this (whether you think so or
 > not).  I am certain that if you try to improve the situation
 > for this use case you can do so, and without spoiling other
 > behavior, even if the fix might not be 100% perfect.  Please
 > give it a try.

I'll do that.

martin